\name{P}
\alias{P}
\title{P: The correlation between gene expression and class  }
\description{
\code{P} computes a statistic defined in Note 16 of Golub et al and
referred to there as a correlation. It is defined for two group problems
and is the difference in means divided by the sum of the within group
standard deviations. 
}
\usage{
P(g, c)
}
\arguments{
  \item{g}{A vector of gene expressions. }
  \item{c}{A vector of class labels }
}
\details{
  Given in the description.
}
\value{
The correlation.
}
\references{ Molecular Classification of Cancer: Class Discovery and
  Class Prediction by 
Gene Expression Monitoring, Science, 531-537, 1999, T. R. Golub and
D. K. Slonim and P. Tamayo and C. Huard and M. Gaasenbeek and
J. P. Mesirov and H. Coller and M.L. Loh and J. R. Downing and
M. A. Caligiuri and C. D. Bloomfield and E. S. Lander
}
\author{R. Gentleman}
\seealso{\code{\link{dovote}}}

\examples{
 set.seed(123)
 P(rnorm(20), rep(1:2, 10))
}
\keyword{manip }
